//
//  TouchReader.m
//  MaskTest
//
//  Created by Sean Christmann on 12/23/08.
//  Copyright 2008 EffectiveUI. All rights reserved.
//

#import "TouchReader.h"
#import "DrawView.h"
#import "MagnifierView.h"

@implementation TouchReader


- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        // Initialization code
		touchTimer = nil;
		loop = nil;
    }
    return self;
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
	touchTimer = [NSTimer scheduledTimerWithTimeInterval:1.0
												 target:self
												selector:@selector( handleAction: )
											   userInfo:touches
												repeats:NO];
	
}
- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event{
	if(loop != nil){
		[self handleAction:touches];
		return;
	}
	[touchTimer invalidate];
	touchTimer = [NSTimer scheduledTimerWithTimeInterval:1.0
												  target:self
												selector:@selector( handleAction: )
												userInfo:touches
												 repeats:NO];
}
- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event{
	[touchTimer invalidate];
	touchTimer = nil;
	[loop removeFromSuperview];
	[loop release];
	loop = nil;
}

- (void) handleAction:(id)timerObj {
	printf("touch go 1 sec\n");
	NSSet *touches;
	if([timerObj isKindOfClass:[NSSet class]]){
		touches = [timerObj retain];
	}else{
		touches = [[timerObj userInfo] retain];
	}
	if(touchTimer != nil){
		[touchTimer invalidate];
		touchTimer = nil;
	}
	if(loop == nil){
		loop = [[MagnifierView alloc] initWithFrame:self.bounds];
		loop.viewref = self;
		[self addSubview:loop];
	}
	
	UITouch *touch = [touches anyObject];
	loop.touchPoint = [touch locationInView:self];
	[loop setNeedsDisplay];
	[touches release];
}

- (void) initTraceableArea {
	DrawView *view1 = [[DrawView alloc] initWithFrame:CGRectMake(0, 0, 320, 100)];
	UIView *im1 = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"rust.jpg"]];
	im1.frame = CGRectMake(0, 0, 100, 100);
	[view1 addSubview:im1];
	[self addSubview:view1];
	[view1 release];
	[im1 release];
	UILabel *label1 = [[UILabel alloc] initWithFrame:CGRectMake(0, 120, 320, 20)];
	label1.text = @"Press and hold to magnify. Drag around after";
	[self addSubview:label1];
	[label1 release];
	UIDatePicker *picker1 = [[UIDatePicker alloc] initWithFrame:CGRectMake(0, 160, 100, 60)];
	[self addSubview:picker1];
	[picker1 release];
	UILabel *label2 = [[UILabel alloc] initWithFrame:CGRectMake(0, 380, 320, 60)];
	label2.numberOfLines = 3;
	label2.text = @"Magnify complex controls by touching outside and moving over control area, or override touches";
	[self addSubview:label2];
	
}

- (void)drawRect:(CGRect)rect {
    // Drawing code
}


- (void)dealloc {
    [super dealloc];
}


@end
